<script>

  import { getContext, onMount, onDestroy  } from 'svelte';
  import MenuItem                            from './MenuItem.svelte';

  const mainContext = getContext('main');

  export let menu     = null;
  export let name     = 'menu-item';
  export let type     = 'check';
  export let label    = 'Menu item';
  export let value    = false;
  export let index    = -1;
  export let depth    = 0;
  export let path     = [];
  export let classes  = [];
  
  export let min  = -Infinity;
  export let max  = +Infinity;
  export let step = 1;

  path = path.slice(0);

  path.push(index);

  export const reset = function(e) {

    const idx = classes.indexOf('active');

    if(idx !== -1)
      classes.splice(idx, 1);

    classes = classes.slice(0);
  }

  export const onItemChange = function(e) {
    e.preventDefault();
    setTimeout(() => {
      value = !e.target.checked;
      window.parent.postMessage(JSON.stringify({action: 'menu_change', data: {name, type, label, value, index, depth, path}}), '*');
    }, 0);
  }

  export const onLabelClick = function(e) {
    e.preventDefault();
    mainContext.reset();
  }

  onMount(() => {
    mainContext.registerReset(reset);
  });

  onDestroy(() => {
    mainContext.unregisterReset(reset);
  });

</script>

<style>
  
  .menu-item {
    text-align: center;
    display: flex;
    flex-direction: column;
    height: 35px;
    line-height: 35px;
    width: 0;
  }
  
  .menu-item:hover {
    user-select: none;
  }
  
  .menu-item .label::before, .menu-item .label::after {
    content: '';
    padding: 0 5px 0 5px;
    display: inline-block;
    height: 35px;
    line-height: 35px;
  }

  .menu-item > .label {
    color: #fff;
    text-align: left;
    background-color: rgba(0, 0, 0, 0.75);
    height: 25px;
    padding: 0 5px 10px 5px;
    border-left: 1px solid rgba(143, 75, 75, 0.75);
    display: flex;
    flex-direction: row;
    justify-content: flex-start;
    white-space: nowrap;
  }

  .menu-item:nth-child(even) > .label {
    background-color: rgba(0, 0, 0, 0.85);
  }

  .menu-item.active > .label {
    color: rgb(170, 60, 60);
  }

  .label-children {
    display: none;
    flex-direction: column;
  }

  .label-value {
    color: rgb(170, 60, 60);
  }

	.label {
    display: flex;
    flex-direction: column;
		color: #000;
  }

  .label-spacer {
    flex-basis: 25px;
  }

  .label-checkbox {
    flex-basis: calc(1/5 * 100%);
  }

  .label-text {
    /* TODO */
  }

  .label-checkbox {
    flex-grow: 1;
    text-align: right;
  }

  .label-checkbox > input[type="checkbox"] {
    transform: scale(1.5);
    text-align: right;
  }

  .label-checkbox:hover > input[type="checkbox"] {
    cursor: pointer;
  }

  .label > input[type="checkbox"]:focus {
    outline: none;
  }

</style>

<div class={`menu-item menu-item-slider ${classes.join(' ')}`}>

  <div class="label" on:click={onLabelClick}>
      <div class="label-spacer" />
      <div class="label-text">{label}</div>
      <div class="label-checkbox">
        <input type="checkbox" bind:checked={value} on:click={onItemChange}/>
      </div>
  </div>

</div>
